summaryrefslogtreecommitdiff
path: root/scripts/sh/spr
diff options
context:
space:
mode:
authorGeorge Abbott <george@gabbott.dev>2025-01-26 11:37:22 +0000
committerGeorge Abbott <george@gabbott.dev>2025-01-26 11:37:22 +0000
commit82abadcecc7534b4847238ee2a977f33256b0439 (patch)
treead8752c1dc9914829e80bc2f3f1a45dfec8f4b4a /scripts/sh/spr
parentbac748dbe8c28cf1ed3b387b24f89ffe5a58ffc9 (diff)
sh
Diffstat (limited to 'scripts/sh/spr')
-rwxr-xr-xscripts/sh/spr50
1 files changed, 50 insertions, 0 deletions
diff --git a/scripts/sh/spr b/scripts/sh/spr
new file mode 100755
index 0000000..93d3e8f
--- /dev/null
+++ b/scripts/sh/spr
@@ -0,0 +1,50 @@
+#!/bin/sh
+# Usage (- represents end of arguments) :-
+# spr - :: opens the raw directory in vim for navigation (sprf is generally better)
+# spr name - :: Opens the file "name"
+# (TODO)spr dir/name - :: Creates "dir" if doesnt exist and opens "dir/name"
+# spr fuzzy :: opens a fuzzy find list of spr files to edit. Shortcut is "sprf"
+# (TODO)spr tree :: opens a tree view of all files. Shortcut is "sprt"
+
+begins_with() { # haystack prefix
+ value=$1
+ prefix=$2
+
+ case "$value" in
+ "$prefix"*) return 0
+ esac
+
+ return 1
+}
+
+[ -z "$EDITOR" ] && echo "EDITOR not set" && exit
+[ -z "$FUZZY" ] && echo "FUZZY not set" && exit
+
+tree() {
+ eza --tree "$HOME/sporadic"
+}
+
+fuzzy() {
+ FILE="$(find "$HOME/sporadic" -type f | $FUZZY)"
+ [ -z "$FILE" ] && exit 0
+ if ! begins_with "$FILE" "$HOME/sporadic" ; then
+ FILE="$HOME/sporadic/$FILE"
+ fi
+
+ mkdir "$(dirname "$FILE")" -p
+ $EDITOR "$FILE"
+}
+
+if [ -z "$1" ] || [ "$1" = "fuzzy" ] ;
+then
+ fuzzy
+ exit 0
+fi
+
+if [ "$1" = "tree" ] ; then
+ tree
+ exit 0
+fi
+
+mkdir "$HOME/sporadic/$(dirname $1)" -p
+$EDITOR "$HOME/sporadic/$1"